EDIT - bug #6228

Fix behavior of multi-language editing
11/30/2016 11:58 AM - Andreas Muller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 90%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.33

Severity: normal Found in Version:

Description

As realized in #6199 multi-language editing does not work correctly yet.
Adding >2 languages, deletes one of the old descriptions so that always only 2 languages remain.
This happens only when saving, while an unsaved TextData shows all existing translations.

Also the behavior of the Translation editor is strange. With a choosen language one would expect that this language is shown on the
right side after opening the Editor, but it always shows no language. One first has to choose the language to translate.

Also it is currently impossible to delete a language.

Partly these issues have been solved for the Term Editor already, but there the data structure is a bit different.

Related issues:

Follows EDIT - bug #6199: Excluded note for excluded taxon nodes in TaxEdtior Closed

Precedes EDIT - bug #6229: Implement multi-language support for MultiLanguage... New

Associated revisions

Revision 32071906 - 08/18/2022 11:53 AM - Katja Luther

ref #10107, #6228: add remove button to MultiLanguageTextElement and fix default text

Revision bff0ad69 - 08/18/2022 12:37 PM - Katja Luther
ref #10107, #6228: fix default language handling

Revision dfb21565 - 09/12/2022 02:54 PM - Katja Luther

ref #6228: remove representation should make the editor dirty

Revision 1ac58a9c - 09/13/2022 01:50 PM - Katja Luther

ref #6228: language drop down should not allow empty selection

Revision 25¢29b34 - 09/15/2022 11:17 AM - Katja Luther

ref #6228: remove empty entry in language combo in translation wizard

Revision 7529454 - 10/04/2022 03:48 PM - Katja Luther

ref #6228: improve translation wizard

Revision 207c5999 - 10/04/2022 03:49 PM - Katja Luther

ref #6228: improve translation wizard - continue

Revision ¢537bcc8 - 10/05/2022 03:34 PM - Katja Luther

ref #6228: improve translation wizard - fix getPreferredLanguage usage

History

#1 - 11/30/2016 12:39 PM - Andreas Miiller
- Due date set to 12/01/2016
- Start date changed from 11/30/2016 to 12/01/2016
https://dev.e-taxonomy.eu/redmine/issues/6199

- Follows bug #6199: Excluded note for excluded taxon nodes in TaxEdtior added

#2 - 11/30/2016 12:58 PM - Andreas Miiller

- Precedes bug #6229: Implement multi-language support for MultiLanguage textes everywhere added

#7 - 08/18/2022 11:51 AM - Katja Luther

- Target version changed from Unassigned CDM tickets to Release 5.33

The issue that only two languages are saved is solved in the meanwhile, the missing deletion was added with the last commit.

#8 - 08/18/2022 11:51 AM - Katja Luther

- Status changed from New to In Progress

#9 - 09/08/2022 12:00 PM - Andreas Miiller
- Status changed from In Progress to Resolved

- Priority changed from New to Highest

#10 - 09/12/2022 02:55 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mtiller

please review

#11 - 09/12/2022 02:55 PM - Katja Luther
- % Done changed from 0 to 50

#12 - 09/13/2022 01:08 PM - Andreas Miiller

- Tags set to i18n

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

Most of the issues are fixed. It is now possible to add >2 languages and to remove a certain translation. This works.

What | do not understand is why it is possible to select from NO language both in the details view and in the translation editor. Was there a usecase
for this?

Also | would expect that the translation editor opens in the language that was chosen in the details view before which is not the case.

However, these 2 issues are minor and may become obsolet once we unify and refactor the i18n handling in all classes in CDM. Therefore we may
implement this now only if it is a no-brainer. Otherwise create a ticket with i18n tag.

#13 - 09/13/2022 01:57 PM - Katja Luther
Andreas Muller wrote in #note-12:
Most of the issues are fixed. It is now possible to add >2 languages and to remove a certain translation. This works.
What | do not understand is why it is possible to select from NO language both in the details view and in the translation editor. Was there a
usecase for this?
This is fixed.
Also | would expect that the translation editor opens in the language that was chosen in the details view before which is not the case.
The language on the left hand side is always the default language if exist, otherwise the "next" language. | think that the default language is on the left
hand side and the "translation" on the right hand side was discussed like that years ago, but maybe I'm wrong.
To change the implementation of the translation wizard should be an extra ticket, because it needs more time.

However, these 2 issues are minor and may become obsolet once we unify and refactor the i18n handling in all classes in CDM. Therefore we
may implement this now only if it is a no-brainer. Otherwise create a ticket with i18n tag.
#14 - 09/13/2022 01:58 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

#15 - 09/14/2022 12:13 AM - Andreas Miiller

- File clipboard-202209140011-vherv.png added

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther
Katja Luther wrote in #note-13:

Andreas Muller wrote in #note-12:

What | do not understand is why it is possible to select from NO language both in the details view and in the translation editor. Was there a
usecase for this?

This is fixed.

| still have the NO language entries in the translation editor:

Add or edit translations.

[Ene nete spracne [ Dekete

dsfsdfa

Eine nette Sprache

#16 - 09/14/2022 12:16 AM - Andreas Miiller
- % Done changed from 50 to 60
Katja Luther wrote in #note-13:

Andreas Muller wrote in #note-12:

Also | would expect that the translation editor opens in the language that was chosen in the details view before which is not the case.

The language on the left hand side is always the default language if exist, otherwise the "next" language. | think that the default language is on
the left hand side and the "translation" on the right hand side was discussed like that years ago, but maybe I'm wrong.

To change the implementation of the translation wizard should be an extra ticket, because it needs more time.

OK, probably you are right. Anyway this will change in future so it will not make much sense to spend time on this now.

#17 - 09/15/2022 11:18 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller
The language combos are without the empty line now.

#18 - 09/30/2022 06:57 PM - Andreas Miiller
- Status changed from Resolved to Feedback
- Assignee changed from Andreas Muiller to Katja Luther

Everything works correct now except for the ride side of the translation editor

1. When opening the trans-editor there is always the first language shown in the language selection combo. But even if a translation already exists
for this language it is not shown.
2. If a translation was chosen in the details view this languages translation/language should be chosen on the right side

3. (only if easy to implement as this will change in future): don't show the language that is selected on the left side as it doesn't make sense to have
the same languages on both sides (but have in mind that language can be changed on the left side, too, therefore | guess we may not want to
implement this now as it is maybe complicated and behavior will change in future)

4. We may also discuss which language should be shown if in details view the default language was selected and if the first language in the combo

does not have a translation yet but if there is a translation for another language. Maybe in this case we should select the first language with an
available translation instead of simply the first language; but this is also only nice to have and not necessary if not fast to implement

#19 - 10/04/2022 03:49 PM - Katja Luther

Andreas Muller wrote in #note-18:
Everything works correct now except for the ride side of the translation editor

1. When opening the trans-editor there is always the first language shown in the language selection combo. But even if a translation already
exists for this language it is not shown. -> fixed

2. If a translation was chosen in the details view this languages translation/language should be chosen on the right side -> fixed

3. (only if easy to implement as this will change in future): don't show the language that is selected on the left side as it doesn't make sense to
have the same languages on both sides (but have in mind that language can be changed on the left side, too, therefore | guess we may not
want to implement this now as it is maybe complicated and behavior will change in future) -> it is not as easy as it seems, so | would do
that later

4. We may also discuss which language should be shown if in details view the default language was selected and if the first language in the
combo does not have a translation yet but if there is a translation for another language. Maybe in this case we should select the first

language with an available translation instead of simply the first language; but this is also only nice to have and not necessary if not fast to
implement -> this is implemented

#20 - 10/04/2022 04:08 PM - Andreas Miiller

for review?
#21 - 10/04/2022 04:14 PM - Katja Luther
Andreas Muller wrote in #note-20:

for review?

maybe | will have a look with nightly before.

#22 - 10/05/2022 04:11 PM - Katja Luther
- Status changed from Feedback to Resolved
- Assignee changed from Katja Luther to Andreas Mdiller
Katja Luther wrote in #note-21:
Andreas Miiller wrote in #note-20:

for review?

maybe | will have a look with nightly before.

now, the issues mentioned above, are fixed now.

#23 - 10/07/2022 12:53 PM - Andreas Miiller

- File clipboard-202210071250-8tsr0.png added

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

- % Done changed from 60 to 90
More or less everything is fixed (except for the filter for the default language as mentioned above).

Only | wonder, why the default language now always appears on top in the dropdown on the right side:

English v m |v|
ABCD ~ Emﬁlish
Achinese —
Afrikaans

Eine nette Sprache

=]

This is outside the alphabetic order which is valid for the remaining languages.

| suggest to fix the only if it is really fast to fix. Otherwise it is of very minor importance and we should concentrate on more important issues. It will
change in future anyway when i18n is reimplemented in model.

Feel free to close immediately or fix remaining issue if fast.

#24 - 10/07/2022 03:53 PM - Katja Luther
- Status changed from Feedback to Closed

Andreas Mller wrote in #note-23:
More or less everything is fixed (except for the filter for the default language as mentioned above).

Only | wonder, why the default language now always appears on top in the dropdown on the right side:

English W m |v|
ABCD ~ EnEIish
Achinese =
Afrikaans

Eine nette Sprache

This is outside the alphabetic order which is valid for the remaining languages.

| suggest to fix the only if it is really fast to fix. Otherwise it is of very minor importance and we should concentrate on more important issues. It
will change in future anyway when i18n is reimplemented in model.

Feel free to close immediately or fix remaining issue if fast.

| can not reproduce this with nightly. So | would close this ticket.

Files
